unit Unit1;

{-------------------------------------------------------------------------------
 >> Demo de uso da P03_Unit <<

        Este demo demonstra como utilizar a unit para capturar informaes
        enviadas ao computador pelas impressoras TOLEDO operando com protocolo
        P03.

        Caso deseje recompilar o programa demo antes de adquirir o fonte da unit,
         necessrio copiar o arquivo P03_Unit.dcu para o diretrio Lib de
        instalao do Delphi, no caso do Delphi 6 pro exemplo
        C:\Arquivos de programas\Borland\Delphi6\Lib

        Caso j tenha adquirido a P03_Unit registrada, voc pode adiciona-la ao
        seu projeto, clicando em Menu> Project> Add to Project.

 Para remover a mensagem de "No Registrado"  necessrio adquirir a P03_Unit
 com fontes. Para informaes sobre como adquirir o produto visite nosso site.

 Atenciosamente,
  Victory Fernandes
   TKS Software
   www.igara.com.br
-------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Buttons, jpeg, ExtCtrls, CPDrv, ShellApi,
  //Caso esteja unsando a unit .DCU no diretrio LIB habilite esta linha abaixo
  P03_Unit;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    Panel1: TPanel;
    TabSheet2: TTabSheet;
    cpDrv: TCommPortDriver;
    Panel3: TPanel;
    RichEdit: TRichEdit;
    RichEdited: TRichEdit;
    Label1: TLabel;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    TabSheet3: TTabSheet;
    TabSheet1: TTabSheet;
    GroupBox6: TGroupBox;
    Label34: TLabel;
    Label35: TLabel;
    GroupBox1: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label3: TLabel;
    Label17: TLabel;
    ComboBox1: TComboBox;
    ComboBox6: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    Label15: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Image3: TImage;
    Label14: TLabel;
    Image4: TImage;
    Label25: TLabel;
    Label26: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label16: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label27: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label18: TLabel;
    Label28: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Image1: TImage;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure cpDrvReceiveData(Sender: TObject; DataPtr: Pointer;
      DataSize: Cardinal);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Label29Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Buffer: String = '';

implementation

//Caso esteja unsando a unit .PAS adicionada ao projeto habilite esta linha abaixo (somente verso registrada)
//uses P03_Unit;

{$R *.dfm}

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
 //Conecta se desconectado
 if cpDrv.Connected then
  begin
   cpDrv.Disconnect
  end
 else
  begin
   cpDrv.BaudRateValue := strtoint(combobox1.text);
   cpDrv.Port          := TPortNumber(combobox6.ItemIndex);
   cpDrv.DataBits      := TDataBits(combobox3.ItemIndex);
   cpDrv.StopBits      := TStopBits(combobox4.ItemIndex);
   cpDrv.StopBits      := TStopBits(combobox4.ItemIndex);
   cpDrv.Parity        := TParity(combobox2.ItemIndex);

   if not cpDrv.Connect then
    Application.MessageBox('No foi possvel conectar a porta serial.'#13#10+
                           'Verifique as configuraes e tente novamente...',
                           'Erro',
                           MB_OK or MB_ICONERROR );
  end;

 //Tratamento dos botes
 BitBtn1.Enabled := not cpDrv.Connected;
 BitBtn2.Enabled := cpDrv.Connected;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
 //Desconecta se conectado
 if cpDrv.Connected then
  cpDrv.Disconnect;

 //Tratamento dos botes
 BitBtn1.Enabled := not cpDrv.Connected;
 BitBtn2.Enabled := cpDrv.Connected;
end;

procedure TForm1.cpDrvReceiveData(Sender: TObject; DataPtr: Pointer;
  DataSize: Cardinal);
var
 temp: string;
 //declarao de variaveis para uso em Trata_Variaveis
 SWA, SWB, SWC, Peso, Tara: string;
 //declarao de variaveis para uso em Trata_SWA
 display, incremento: string; paridade_par_SWA: boolean;
 //declarao de variaveis para uso em Trata_SWB
 peso_liquido, peso_negativo, sobrecarga, motion, auto_zerado, paridade_par_SWB: boolean;
 //declarao de variaveis para uso em Trata_SWC
 tecla_imprimir, expandido, paridade_par_SWC: boolean;
begin
  //Captura dados lidos em formato string
  temp := StringOfChar(' ', DataSize);
  move(DataPtr^, pchar(temp)^, DataSize);

  //Remove caracteres invalidos da string lida
  temp := Remove_Invalidos(temp);

  //Caso o 15 bytes (sem checksum) no tenham sido todos lidos incrementa buffer
  if length(buffer) < 15 then
   begin
    buffer := buffer + temp;
   end;

  if length(buffer) >= 15 then
   begin
    //Limpa RichEdits
    RichEdit.Lines.Clear;
    RichEdited.Lines.Clear;

    //Acrescenta o string lida no primeiro RichEdit
    RichEdit.Lines.Append(buffer);

    //Trata string lida conforme protocolo P03 da Toledo
    Trata_Buffer(Buffer, SWA, SWB, SWC, Peso, Tara);
    Trata_SWA(SWA, display, incremento, paridade_par_SWA);
    Trata_SWB(SWB, peso_liquido, peso_negativo, sobrecarga, motion, auto_zerado, paridade_par_SWB);
    Trata_SWC(SWC, tecla_imprimir, expandido, paridade_par_SWC);

    //Adiciona variaveis tratadas ao segundo RichEdit
    with RichEdited.Lines do
     begin
      Append('SWA = ' + SWA);
      Append(' Display = ' +      display);
      Append(' Incremento = ' +   incremento);
      Append(' Paridade Par = ' + BoolToStr(paridade_par_SWA, True));
      Append('');

      Append('SWB = ' + SWB);
      Append(' Peso Liquido = ' +  BoolToStr(peso_liquido, True));
      Append(' Peso Negativo = ' + BoolToStr(peso_negativo, True));
      Append(' Sobre Carga = ' +   BoolToStr(sobrecarga, True));
      Append(' Motion = ' +        BoolToStr(motion, True));
      Append(' Auto Zerado = ' +   BoolToStr(auto_zerado, True));
      Append(' Paridade Par = ' +  BoolToStr(paridade_par_SWB, True));
      Append('');

      Append('SWC = ' + SWC);
      Append(' Tecla Imprimir = ' + BoolToStr(tecla_imprimir, True));
      Append(' Expandido = ' +      BoolToStr(expandido, True));
      Append(' Paridade Par = ' +   BoolToStr(paridade_par_SWC, True));
      Append('');

      Append('Peso = ' + Peso);

      try
       Append('Peso Formatado = ' + floattostr(strtofloat(Peso) * strtofloat(display)));
      except
       Append('Peso Formatado = ' + 'Erro de formatao de peso, verifique os parmetros de configurao da conexo do aplicativo e da balana (eles devem coincidir)');
      end;

      Append('Tara = ' + Tara);

      try
       Append('Tara Formatada = ' + floattostr(strtofloat(Tara) * strtofloat(display)));
      except
       Append('Peso Formatado = ' + 'Erro de formatao de peso, verifique os parmetros de configurao da conexo do aplicativo e da balana (eles devem coincidir)');      end;
      end;

    Buffer := '';
   end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 BitBtn2.Click;

 Action := caFree;
end;

procedure TForm1.Label29Click(Sender: TObject);
begin
  ShellExecute(Self.Handle, nil, PChar(TLabel(sender).caption), nil, nil, SW_NORMAL);
end;

end.
