unit Unit1;

{-------------------------------------------------------------------------------
 >> Demo de uso da P05a_Unit <<

        Este demo demonstra como utilizar a unit para capturar informaes
        enviadas ao computador pelas impressoras TOLEDO operando com protocolo
        P05a.

        Caso deseje recompilar o programa demo antes de adquirir o fonte da unit,
         necessrio copiar o arquivo P05a_Unit.dcu para o diretrio Lib de
        instalao do Delphi, no caso do Delphi 6 pro exemplo
        C:\Arquivos de programas\Borland\Delphi6\Lib

        Caso j tenha adquirido a P05a_Unit registrada, voc pode adiciona-la ao
        seu projeto, clicando em Menu> Project> Add to Project.

 Para remover a mensagem de "No Registrado"  necessrio adquirir a P05a_Unit
 com fontes. Para informaes sobre como adquirir o produto visite nosso site.

 Atenciosamente,
  Victory Fernandes
   TKS Software
   www.igara.com.br
-------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Buttons, jpeg, ExtCtrls, CPDrv, ShellApi,
  //Caso esteja unsando a unit .DCU no diretrio LIB habilite esta linha abaixo
  P05A_Unit;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    Panel1: TPanel;
    TabSheet2: TTabSheet;
    cpDrv: TCommPortDriver;
    Panel3: TPanel;
    RichEdit: TRichEdit;
    RichEdited: TRichEdit;
    Label1: TLabel;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    TabSheet3: TTabSheet;
    TabSheet1: TTabSheet;
    GroupBox6: TGroupBox;
    Label34: TLabel;
    Label35: TLabel;
    GroupBox1: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label3: TLabel;
    Label17: TLabel;
    ComboBox1: TComboBox;
    ComboBox6: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    Label15: TLabel;
    Image1: TImage;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Image3: TImage;
    Label14: TLabel;
    Image2: TImage;
    Label25: TLabel;
    Label26: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label16: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label27: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure cpDrvReceiveData(Sender: TObject; DataPtr: Pointer;
      DataSize: Cardinal);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Label29Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Buffer: String = '';

implementation

//Caso esteja usando a unit .PAS adicionada ao projeto habilite esta linha abaixo (somente verso registrada)
//uses P05a_Unit;

{$R *.dfm}

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
 //Conecta se desconectado
 if cpDrv.Connected then
  begin
   cpDrv.Disconnect
  end
 else
  begin
   cpDrv.BaudRateValue := strtoint(combobox1.text);
   cpDrv.Port          := TPortNumber(combobox6.ItemIndex);
   cpDrv.DataBits      := TDataBits(combobox3.ItemIndex);
   cpDrv.StopBits      := TStopBits(combobox4.ItemIndex);
   cpDrv.StopBits      := TStopBits(combobox4.ItemIndex);
   cpDrv.Parity        := TParity(combobox2.ItemIndex);

   if not cpDrv.Connect then
    Application.MessageBox('No foi possvel conectar a porta serial.'#13#10+
                           'Verifique as configuraes e tente novamente...',
                           'Erro',
                           MB_OK or MB_ICONERROR )
   else
    begin
     //Envia String 'ENQ' para iniciar o envio de dados pela balana. 
     if not CpDrv.SendString('ENQ')then
      Application.MessageBox('A porta serial no foi aberta, ou o dado no foi enviado completamente'+#13+#10+' durante o tempo de envio.'+#13+#10+'', 'Ateno!', mb_ok + mb_iconWarning);
    end;
  end;

 //Tratamento dos botes
 BitBtn1.Enabled := not cpDrv.Connected;
 BitBtn2.Enabled := cpDrv.Connected;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
 //Desconecta se conectado
 if cpDrv.Connected then
  cpDrv.Disconnect;

 //Tratamento dos botes
 BitBtn1.Enabled := not cpDrv.Connected;
 BitBtn2.Enabled := cpDrv.Connected;
end;

procedure TForm1.cpDrvReceiveData(Sender: TObject; DataPtr: Pointer;
  DataSize: Cardinal);
var
 temp, peso: string;
begin
  //Captura dados lidos em formato string
  temp := StringOfChar(' ', DataSize);
  move(DataPtr^, pchar(temp)^, DataSize);
  //Remove caracteres invalidos da string lida
  temp := Remove_Invalidos(temp);
  //Caso o 5 bytes (sem checksum) no tenham sido todos lidos incrementa buffer
  if length(buffer) < 5 then
   begin
    buffer := buffer + temp;
   end;

  if length(buffer) >= 5 then
   begin
    //Limpa RichEdits
    RichEdit.Lines.Clear;
    RichEdited.Lines.Clear;

    //Acrescenta o string lida no primeiro RichEdit
    RichEdit.Lines.Append(buffer);

    //Trata string lida conforme protocolo P05a da Toledo
    Trata_Buffer(Buffer, Peso);

    //Adiciona variaveis tratadas ao segundo RichEdit
    with RichEdited.Lines do
     begin
      Append('Peso = ' + Peso);
     end;
    Buffer := '';
   end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 BitBtn2.Click;

 Action := caFree;
end;

procedure TForm1.Label29Click(Sender: TObject);
begin
  ShellExecute(Self.Handle, nil, PChar(TLabel(sender).caption), nil, nil, SW_NORMAL);
end;

end.
